标签:有一个 check 输入输出格式 its Fix cst tle upload set
kotori 有 n 个可同时使用的设备。
第 i 个设备每秒消耗ai个单位能量。能量的使用是连续的,也就是说能量不是某时刻突然消耗的,而是匀速消耗。也就是说,对于任意实数 ,在 k 秒内消耗的能量均为k*ai 单位。在开始的时候第 i 个设备里存储着bi个单位能量。
同时 kotori 又有一个可以给任意一个设备充电的充电宝,每秒可以给接通的设备充能p 个单位,充能也是连续的,不再赘述。你可以在任意时间给任意一个设备充能,从一个设备切换到另一个设备的时间忽略不计。
kotori 想把这些设备一起使用,直到其中有设备能量降为 0。所以 kotori 想知道,
在充电器的作用下,她最多能将这些设备一起使用多久。
第一行给出两个整数 n,p。
接下来 n 行,每行表示一个设备,给出两个整数,分别是这个设备的ai 和 bi。
如果 kotori 可以无限使用这些设备,输出-1。
否则输出 kotori 在其中一个设备能量降为 0 之前最多能使用多久。
设你的答案为 a,标准答案为 b,只有当 a,b 满足 的时候,你能得到本测 试点的满分。
2 1
2 2
2 1000
2.0000000000
1 100
1 1
-1
3 5
4 3
5 2
6 1
0.5000000000
对于 100%的数据, 1<=n<=100000,1<=p<=100000,1<=ai,bi<=100000。
此题妥妥的二分答案,不知道为什么是蓝题。
二分使用时间,看看能不能用。
当然我们需要特判,如果所有设备的耗电速度加起来都比不上充电速度,那么显然kotori可以无限使用设备,输出-1.
/*
* @Author: crab-in-the-northeast
* @Date: 2020-06-20 12:02:51
* @Last Modified by: crab-in-the-northeast
* @Last Modified time: 2020-06-20 14:58:15
*/
#include <iostream>
#include <cstdio>
#include <climits>
#include <iomanip>
const int maxn = 100005;
const double eps = 1e-6;//eps最低只能到这个值,亲测到1e-7会有一个点TLE
int n, p;
double a[maxn], b[maxn];
bool check(double x) {
double need = 0;
for (int i = 1; i <= n; ++i)
if (b[i] < a[i] * x)
need += a[i] * x - b[i];
return need <= p * x;
}
int main() {
std :: cin >> n >> p;
for (int i = 1; i <= n; ++i)
std :: cin >> a[i] >> b[i];
double sum = 0;
for (int i = 1; i <= n; ++i)
sum += a[i];
if (sum <= p) {
std :: cout << -1 << std :: endl;
return 0;
}
double l = 0;
double r = 3000000001;
//之前r一直定的是2147483647,但是结果有一个点WA掉了,参考题解才发现是r定太小。
while (r - l > eps) {
double mid = (l + r) / 2;
if (check(mid)) l = mid;
else r = mid;
}
std :: cout << std :: fixed << std :: setprecision(8) << r << std :: endl; //之前eps定的是1e-9所以我就定的是八位输出,后来改成1e-6但是这里懒得改了
}
标签:有一个 check 输入输出格式 its Fix cst tle upload set
原文地址:https://www.cnblogs.com/crab-in-the-northeast/p/luogu-p3743.html